/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from linux-dmabuf-unstable-v1.xml
 * To regenerate, run the “refresh-wayland-wrapper” target.
 */

#ifndef MIR_FRONTEND_WAYLAND_LINUX_DMABUF_UNSTABLE_V1_XML_WRAPPER
#define MIR_FRONTEND_WAYLAND_LINUX_DMABUF_UNSTABLE_V1_XML_WRAPPER

#include <experimental/optional>

#include "mir/fd.h"
#include <wayland-server-core.h>

#include "mir/wayland/wayland_base.h"

namespace mir
{
namespace wayland
{

class LinuxDmabufV1;
class LinuxBufferParamsV1;

class LinuxDmabufV1 : public Resource
{
public:
    static char const constexpr* interface_name = "zwp_linux_dmabuf_v1";

    static LinuxDmabufV1* from(struct wl_resource*);

    LinuxDmabufV1(struct wl_resource* resource, Version<3>);
    virtual ~LinuxDmabufV1();

    void send_format_event(uint32_t format) const;
    bool version_supports_modifier();
    void send_modifier_event(uint32_t format, uint32_t modifier_hi, uint32_t modifier_lo) const;

    void destroy_wayland_object() const;

    struct wl_client* const client;
    struct wl_resource* const resource;

    struct Opcode
    {
        static uint32_t const format = 0;
        static uint32_t const modifier = 1;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

    class Global : public wayland::Global
    {
    public:
        Global(wl_display* display, Version<3>);

        auto interface_name() const -> char const* override;

    private:
        virtual void bind(wl_resource* new_zwp_linux_dmabuf_v1) = 0;
        friend LinuxDmabufV1::Thunks;
    };

private:
    virtual void destroy() = 0;
    virtual void create_params(struct wl_resource* params_id) = 0;
};

class LinuxBufferParamsV1 : public Resource
{
public:
    static char const constexpr* interface_name = "zwp_linux_buffer_params_v1";

    static LinuxBufferParamsV1* from(struct wl_resource*);

    LinuxBufferParamsV1(struct wl_resource* resource, Version<3>);
    virtual ~LinuxBufferParamsV1();

    void send_created_event(struct wl_resource* buffer) const;
    void send_failed_event() const;

    void destroy_wayland_object() const;

    struct wl_client* const client;
    struct wl_resource* const resource;

    struct Error
    {
        static uint32_t const already_used = 0;
        static uint32_t const plane_idx = 1;
        static uint32_t const plane_set = 2;
        static uint32_t const incomplete = 3;
        static uint32_t const invalid_format = 4;
        static uint32_t const invalid_dimensions = 5;
        static uint32_t const out_of_bounds = 6;
        static uint32_t const invalid_wl_buffer = 7;
    };

    struct Flags
    {
        static uint32_t const y_invert = 1;
        static uint32_t const interlaced = 2;
        static uint32_t const bottom_first = 4;
    };

    struct Opcode
    {
        static uint32_t const created = 0;
        static uint32_t const failed = 1;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void destroy() = 0;
    virtual void add(mir::Fd fd, uint32_t plane_idx, uint32_t offset, uint32_t stride, uint32_t modifier_hi, uint32_t modifier_lo) = 0;
    virtual void create(int32_t width, int32_t height, uint32_t format, uint32_t flags) = 0;
    virtual void create_immed(struct wl_resource* buffer_id, int32_t width, int32_t height, uint32_t format, uint32_t flags) = 0;
};

}
}

#endif // MIR_FRONTEND_WAYLAND_LINUX_DMABUF_UNSTABLE_V1_XML_WRAPPER
